<template>
  <title-header
    :title="$t('account')"
    style="
      border-bottom: 0px;
      z-index: 10;
      background: transparent;
      margin-top: 0.25rem;
    "
  />
  <div class="bg-background2">
    <div class="px-5 m-page-header bg-x0030">
      <div class="overflow-hidden background-header-title"></div>
    </div>
    <div class="fixed w-full p-5 pt-0 h-full">
      <div class="flex flex-col padding-x h-full mt-2">
        <account-info-component />
        <div class="rounded-lg mt-6 pb-[8rem] h-full overflow-y-scroll">
          <div
            class="flex flex-col pl-5 pr-5 rounded-lg bg-background1 padding-x"
          >
            <div class="flex flex-col">
              <nuxt-link
                class="py-[16.5px] m-profile-menu-item"
                :to="isLoggedIn ? '/account' : '/login'"
                :id = "`${ID.USER_CENTER.ACCOUNT}`"
              >
                <div class="flex items-center justify-between pointer-events-none">
                  <div class="flex items-center fc-text">
                    <svg-icon
                      svg-name="icon-profile"
                      class="icon w-[21px] h-[21px]"
                      style="fill: white"
                    />
                    <span class="profile-menu-title">{{ $t("profile") }}</span>
                  </div>
                  <div class="flex items-center m-angle-right-container">
                    <font-awesome-icon
                      icon="angle-right"
                      style="color: white"
                    />
                  </div>
                </div>
              </nuxt-link>
              <nuxt-link
                class="py-[16.5px] m-profile-menu-item"
                :to="isLoggedIn ? '/wallet' : '/login'"
                :id = "`${ID.USER_CENTER.WALLET}`"
              >
                <div class="flex justify-between pointer-events-none">
                  <div class="flex items-center fc-text">
                    <svg-icon
                      svg-name="icon-aWallet"
                      class="icon w-[21px] h-[21px]"
                      style="fill: white"
                    />
                    <span class="profile-menu-title">{{ $t("wallet") }}</span>
                  </div>
                  <div class="flex items-center m-angle-right-container">
                    <font-awesome-icon
                      icon="angle-right"
                      style="color: white"
                    />
                  </div>
                </div>
              </nuxt-link>
              <nuxt-link
                class="py-[16.5px] m-profile-menu-item"
                :to="isLoggedIn ? '/bet-history' : '/login'"
                :id = "`${ID.USER_CENTER.BET_HISTORY}`"
              >
                <div class="flex justify-between pointer-events-none">
                  <div class="flex items-center fc-text">
                    <!-- <span v-html="betHistoryIcon" class="icon"></span> -->
                    <svg-icon
                      svg-name="icon-fBetHistory"
                      class="icon w-[21px] h-[21px]"
                      style="fill: white"
                    />
                    <span class="profile-menu-title">{{
                      $t("bet_history")
                    }}</span>
                  </div>
                  <div class="flex items-center m-angle-right-container">
                    <font-awesome-icon
                      icon="angle-right"
                      style="color: white"
                    />
                  </div>
                </div>
              </nuxt-link>
              <nuxt-link
                class="py-[16.5px] m-profile-menu-item"
                :to="isLoggedIn ? '/transaction-history' : '/login'"
                :id = "`${ID.USER_CENTER.TRANSACTION_HISTORY}`"
              >
                <div class="flex justify-between pointer-events-none">
                  <div class="flex items-center fc-text">
                    <!-- <span v-html="statementIcon" class="icon"></span> -->
                    <svg-icon
                      svg-name="icon-statement"
                      class="icon w-[21px] h-[21px]"
                      style="fill: white"
                    />
                    <span class="profile-menu-title">{{
                      $t("statement")
                    }}</span>
                  </div>
                  <div class="flex items-center m-angle-right-container">
                    <font-awesome-icon
                      icon="angle-right"
                      style="color: white"
                    />
                  </div>
                </div>
              </nuxt-link>
              <nuxt-link
                v-if="referralEnabled && !isV2ReferralEnabled"
                :to="isLoggedIn ? '/referral' : '/login'"
                class="py-[16.5px] m-profile-menu-item"
                :id = "`${ID.USER_CENTER.REFERRAL}`"
              >
                <div class="flex justify-between pointer-events-none">
                  <div class="flex items-center fc-text">
                    <svg-icon
                      svg-name="icon-referral"
                      class="icon w-[21px] h-[21px]"
                      style="fill: white"
                    />
                    <!-- <img :src="getAssetImage('assets/theme/new_black_theme/profile/Referral.svg')" alt="" class="m-0 w-[24px] h-[24px]"> -->
                    <span class="profile-menu-title">{{ $t("referral") }}</span>
                  </div>
                  <div class="flex items-center m-angle-right-container">
                    <font-awesome-icon
                      icon="angle-right"
                      style="color: white"
                    />
                  </div>
                </div>
              </nuxt-link>
              <nuxt-link
                v-if="isReferralV2Enabled && isShowReferralPage"
                :to="isLoggedIn ? '/referral-v2/information' : '/login'"
                class="py-[16.5px] m-profile-menu-item"
                :id = "`${ID.USER_CENTER.REFERRAL}`"
              >
                <div class="flex justify-between pointer-events-none">
                  <div class="flex items-center fc-text">
                    <svg-icon
                      svg-name="icon-referral"
                      class="icon w-[21px] h-[21px]"
                      style="fill: white"
                    />
                    <!-- <img :src="getAssetImage('assets/theme/new_black_theme/profile/Referral.svg')" alt="" class="m-0 w-[24px] h-[24px]"> -->
                    <span class="profile-menu-title">{{ $t("referral") }}</span>
                  </div>
                  <div class="flex items-center m-angle-right-container">
                    <font-awesome-icon
                      icon="angle-right"
                      style="color: white"
                    />
                  </div>
                </div>
              </nuxt-link>
              <nuxt-link
                :to="isLoggedIn ? '/messages' : '/login'"
                class="py-[16.5px] m-profile-menu-item"
                :id = "`${ID.USER_CENTER.MESSAGE}`"
              >
                <div class="flex justify-between pointer-events-none">
                  <div class="flex items-center fc-text">
                    <svg-icon
                      svg-name="icon-message-fill"
                      class="!fill-[var(--text5)] icon w-[24px] h-[21px] mt-[-2px]"
                    />
                    <span class="profile-menu-title">{{ $t("messages") }}</span>
                    <MessagesMessageCount
                      v-if="unreadInfo && unreadInfo.TotalCount"
                      :count="unreadInfo.TotalCount"
                      :is-unread="true"
                      class="!ml-2"
                    ></MessagesMessageCount>
                  </div>
                  <div class="flex items-center m-angle-right-container">
                    <font-awesome-icon
                      icon="angle-right"
                      style="color: white"
                    />
                  </div>
                </div>
              </nuxt-link>
              <div
                v-if="!agentCooperation.IsHidden"
                class="py-[16.5px] m-profile-menu-item"
                @click="toggleAgentCooperation"
              >
                <div class="flex justify-between">
                  <div class="flex items-center fc-text">
                    <svg-icon
                      svg-name="icon-people"
                      class="icon w-[21px] h-[21px]"
                      style="fill: white"
                    />
                    <!-- <img :src="getAssetImage('assets/svg-icon/people.svg')" class="m-0 w-[24px] h-[24px]"> -->
                    <span class="profile-menu-title">{{
                      $t("agent_cooperation")
                    }}</span>
                  </div>
                  <div class="flex items-center m-angle-right-container">
                    <font-awesome-icon
                      icon="angle-right"
                      style="color: white"
                    />
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div class="flex flex-col rounded-lg px-5 bg-background1 mt-[10px]">
            <nuxt-link
              class="py-[16.5px] m-profile-menu-item"
              to="/help-center"
            >
              <div class="flex justify-between">
                <div class="flex items-center fc-text">
                  <svg-icon
                    svg-name="icon-aboutus"
                    class="icon w-[21px] h-[21px]"
                    style="fill: white"
                  />
                  <!-- <img :src="getAssetImage('assets/theme/new_black_theme/AboutUs.svg')" alt="" class="m-0 w-[24px] h-[24px]"> -->
                  <span class="profile-menu-title">{{
                    $t("help_center")
                  }}</span>
                </div>
                <div class="flex items-center m-angle-right-container">
                  <font-awesome-icon icon="angle-right" style="color: white" />
                </div>
              </div>
            </nuxt-link>
          </div>
          <div
            class="flex flex-col px-5 rounded-lg bg-background1 lang-wr-option-container"
          >
            <el-collapse v-model="activeNames">
              <el-collapse-item name="language">
                <template #title>
                  <div class="flex items-center justify-between w-full">
                    <div class="flex items-center fc-text">
                      <div class="icon-lang">
                        <img
                          :src="
                            getAssetImage(
                              `assets/materials/languageIcon/${defaultLanguage}.svg`
                            )
                          "
                          alt=""
                        />
                      </div>
                      <span class="profile-menu-title">{{
                        defaultLanguageForDisplay
                      }}</span>
                    </div>
                    <div class="flex items-center m-angle-right-container">
                      <font-awesome-icon
                        icon="angle-down"
                        class="m-language-collapse"
                      />
                    </div>
                  </div>
                </template>
                <div>
                  <div v-for="(lang, index) in languages" :key="index">
                    <div
                      class="flex items-center cursor-pointer padding-y fc-text"
                      @click="switchLanguage(lang.ISO)"
                    >
                      <div class="icon-lang">
                        <img
                          :src="
                            getAssetImage(
                              `assets/materials/languageIcon/${lang.ISO}.svg`
                            )
                          "
                          alt=""
                          :loading="lazy"
                        />
                      </div>
                      <div class="profile-menu-title">
                        {{ lang.LanguageLocalName }}
                      </div>
                    </div>
                  </div>
                </div>
              </el-collapse-item>
            </el-collapse>
          </div>
          <div
            v-if="!isBSI"
            class="mt-8 flex flex-col px-5 rounded-lg bg-background1 mb-[10px]"
          >
            <div class="py-[16.5px] m-profile-menu-item" @click="onLogout">
              <div class="flex justify-between">
                <div class="flex items-center fc-text">
                  <svg-icon
                    svg-name="icon-signout"
                    class="icon w-[21px] h-[21px]"
                    style="fill: white"
                  />
                  <span class="profile-menu-title">{{ $t("logout") }}</span>
                </div>
                <div class="flex items-center m-angle-right-container">
                  <font-awesome-icon icon="angle-right" style="color: white" />
                </div>
              </div>
            </div>
          </div>
          <div
            v-if="isBSI"
            class="mt-8 flex flex-col px-5 rounded-lg bg-background1 mb-[10px]"
          >
            <nuxt-link
              to="/login"
              class="py-[16.5px] m-profile-menu-item profile-menu-title text-center"
            >
              {{ $t("capital_login") }}
            </nuxt-link>
          </div>
        </div>
      </div>
    </div>
    <hamburger-menu />
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from "vue";
import AccountInfoComponent from "./components/AccountInfo.client.vue";
import TitleHeader from "./components/ui/TitleHeader.client.vue";
import {
  useLanguageComponent,
  useHeaderComponent,
} from "@/composables/useTheme";
import { store } from "@/store";
import { ID } from "~~/utils/constants";

export default defineComponent({
  name: "Profile",
  components: {
    AccountInfoComponent,
    TitleHeader,
  },
  setup() {
    const activeNames = ref([]);
    const router = useRouter();
    const isLoggedIn = computed(() => store.state.auth);
    const toggleAgentCooperation = () => {
      store.commit(
        "updateAgentCooperationDialog",
        !store.state.showAgentCooperationDialog
      );
    };
    const { logout, referralEnabled, agentCooperation, isReferralV2Enabled } = useHeaderComponent();
    const isShowReferralPage = computed(() => store.state.IsShowReferralPage);
    const onLogout = () => {
      if (isLoggedIn.value) {
        logout();
      } else {
        router.push("/login");
      }
    };

    const {
      languages,
      defaultLanguage,
      switchLanguage,
      defaultLanguageForDisplay,
    } = useLanguageComponent();
    const isBSI = computed(() => !store.state.auth);
    const onNavigateToPage = (url: string) => {
      if (isBSI.value) {
        router.push("/login");
      } else {
        window.open(url, "_blank");
      }
    };
    const { getAssetImage } = commonHelper;
    const accountBgImg = `url(${getAssetImage(
      "assets/theme/new_black_theme/profile_bg.png"
    )})`;
    const { fetchMessages, unreadInfo } = useMessage();
    const route = useRoute();
    onMounted(() => {
      if (!route.fullPath.includes("messages")) {
        fetchMessages();
      }
    });
    return {
      activeNames,
      languages,
      defaultLanguage,
      switchLanguage,
      defaultLanguageForDisplay,
      isBSI,
      onLogout,
      onNavigateToPage,
      referralEnabled,
      agentCooperation,
      getAssetImage,
      accountBgImg,
      toggleAgentCooperation,
      isLoggedIn,
      isReferralV2Enabled,
      isShowReferralPage,
      unreadInfo,
    };
  },
});
</script>

<style lang="scss" scoped>
.hamburger-pos {
  display: none;
}
.el-collapse {
  --el-collapse-content-bg-color: none;
  --el-collapse-header-bg-color: none;
  border: none;
  :deep(.el-collapse-item__arrow) {
    font-weight: bold;
    color: var(--text);
  }
}
:deep(.icon svg) {
  width: 24px;
  height: 24px;
}
:deep(.icon svg path) {
  fill: var(--text);
}
.icon-lang {
  img {
    width: 100%;
    height: 100%;
    border-radius: 2px;
    object-fit: cover;
  }
  height: 16px;
  width: 22px;
  border-radius: 2px;
  background: #fff;
}
.svg-inline--fa {
  color: var(--text);
}
</style>
<style lang="scss">
.background-header-title {
  position: absolute;
  height: 184px;
  width: 100%;
  background-color: transparent;
  top: 0;
  left: 0;
  &::before {
    background: linear-gradient(108deg, #3f1ec5, #a73fd4) no-repeat 50%;
    border-radius: 50%;
    content: "";
    height: 12.5rem;
    left: 50%;
    position: absolute;
    top: 20%;
    transform: translate(-50%, -50%);
    width: 150%;
  }
}
.m-account-header-title::before {
  background-image: v-bind(accountBgImg);
  content: "";
  height: 184px;
  left: 0;
  position: fixed;
  top: 0;
  width: 100%;
  background-size: cover;
  filter: grayscale(100%);
}
.m-profile-menu-item {
  border-bottom: 0.5px solid #393c68;
}
.m-profile-menu-item:last-child {
  border-bottom: none;
}
.m-angle-right-container {
  height: 21.83px;
  width: 21.83px;
  display: flex;
  justify-content: center;
  color: var(--textBtn);
}
.m-angle-right-container svg {
  font-size: 16.31px;
}
.profile-menu-title {
  font-size: 15px;
  // color: var(--text);
  color: white;
  font-weight: bold;
  margin-left: 8.73px;
}
.el-collapse-item__arrow {
  display: none;
}
.el-collapse-item__header,
.el-collapse-item__wrap {
  border-bottom: unset;
}
.el-collapse-item .m-language-collapse {
  transition: transform 0.3s ease-in-out;
}
.el-collapse-item.is-active .m-language-collapse {
  transform: rotate(-180deg);
}
.lang-wr-option-container {
  padding-top: 4.87px;
  padding-bottom: 4.87px;
  margin-top: 10px !important;
  margin-bottom: 10px !important;
}
.m-profile-item-btn {
  font-size: 15.82px;
  color: var(--textBtn);
  border: unset;
  padding: var(--padding-x);
  height: 52.31px;
  border-radius: 0.5rem;
}
.padding-y {
  padding-top: 12.25px;
  padding-bottom: 12.25px;
}
.m-margin-unset {
  margin-top: 10px;
}
</style>
